<?php  if (!defined('BASE_DIR')) exit('No direct script access allowed');
/*
 * http://maxsite.org/page/php-microframework
*/

// define app dirs
define('APP_CONFIG_DIR',   APP_DIR . 'framework/config/');

define('APP_MODULE_DIR',   APP_DIR . 'framework/module/');
define('APP_LIB_DIR',      APP_DIR . 'framework/lib/');
define('APP_COMPOSER_DIR', APP_DIR . 'framework/vendor/');

// define system dirs
define('SYS_MODULE_DIR',   SYS_DIR . 'module/');
define('SYS_LIB_DIR',      SYS_DIR . 'lib/');
define('SYS_COMPOSER_DIR', SYS_DIR . 'vendor/');

// autoload composer
if (file_exists(APP_COMPOSER_DIR . 'autoload.php')) require APP_COMPOSER_DIR . 'autoload.php'; 
if (file_exists(SYS_COMPOSER_DIR . 'autoload.php')) require SYS_COMPOSER_DIR . 'autoload.php'; 

// autoload lib non psr-4
if (file_exists(APP_LIB_DIR . 'autoload.php')) require APP_LIB_DIR . 'autoload.php'; 
if (file_exists(SYS_LIB_DIR . 'autoload.php')) require SYS_LIB_DIR . 'autoload.php'; 

// register autoload classes PSR-4
// priority: APP_MODULE_DIR, SYS_MODULE_DIR, APP_LIB_DIR, SYS_LIB_DIR
spl_autoload_register(function($class) {
	$a = explode('\\', $class);
	$fn = $class . '/' . array_pop($a) . '.php';
	$fn = str_replace('\\', '/', $fn);
	
	if (file_exists(APP_MODULE_DIR . $fn)) require APP_MODULE_DIR . $fn;
	else if (file_exists(SYS_MODULE_DIR . $fn)) require SYS_MODULE_DIR . $fn;
	else if (file_exists(APP_LIB_DIR . $fn)) require APP_LIB_DIR . $fn;
	else if (file_exists(SYS_LIB_DIR . $fn)) require SYS_LIB_DIR . $fn;
});

// load config application
$config = (file_exists(APP_CONFIG_DIR . 'config.php')) ? require APP_CONFIG_DIR . 'config.php' : array();

//
// ... use config application ...
//

// deleting $config
unset($config);

// run application
if (file_exists(APP_DIR . 'app.php')) require APP_DIR . 'app.php'; 

# end of file